﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.IO;
using System.Windows.Media.Imaging;

namespace SilverlightAsDropTarget
{
    public partial class MainPage : UserControl
    {
        ObservableCollection<BitmapImage> _images = new ObservableCollection<BitmapImage>();

        public MainPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            ImageList.ItemsSource = _images;
            ImagesTarget.Drop += new DragEventHandler(ImagesTarget_Drop);
        }

        void ImagesTarget_Drop(object sender, DragEventArgs e)
        {
            if (e.Data == null)
                return;

            IDataObject dataObject = e.Data as IDataObject;
            FileInfo[] files =
              dataObject.GetData(DataFormats.FileDrop) as FileInfo[];

            foreach (FileInfo file in files)
            {
                try
                {
                    using (var stream = file.OpenRead())
                    {
                        var imageSource = new BitmapImage();
                        imageSource.SetSource(stream);
                        _images.Add(imageSource);
                    }
                }
                catch (Exception)
                {
                    MessageBox.Show("Not a suppoted image.");
                } 
            } 
        }
    }
}
